part of ebisu_cpp.qt_support;

/// Wrapper for classes requiring Q_OBJECT
class QtClass extends Class {
  // custom <class QtClass>

  QtClass(id) : super(id) {
    withCustomBlock(clsOpen, (CodeBlock cb) {
      cb.snippets.add('Q_OBJECT');
    });
    customBlocks.add(clsPublic);
  }

  onOwnershipEstablished() {
    super.onOwnershipEstablished();
    members.where((m) => looksLikeHasQtName(m.type)).forEach((var m) {
      final match = _qtLikeNameRe.firstMatch(m.type);
      final cls = match.group(0);
      final ns = qtClassToNamespace[cls];
      if (ns != null) {
        this.includes.add('$cls');
      }
    });
  }

  // end <class QtClass>

}

/// Wrapper for qt qui app
class QtApp extends App {
  // custom <class QtApp>

  QtApp(id) : super(id) {}

  onOwnershipEstablished() {
    super.onOwnershipEstablished();
  }

  // end <class QtApp>

}

// custom <part qt_basics>

qtClass(id) => new QtClass(id);
qtApp(id) => new QtApp(id);

final qtClassToNamespace = {
  "QPlainTextDocumentLayout": "QtWidgets",
  "QDial": "QtWidgets",
  "QAccessibleDialogButtonBox": "QtWidgets",
  "QGesture": "QtWidgets",
  "QAccessibleMenu": "QtWidgets",
  "QFrame": "QtWidgets",
  "QUndoStack": "QtWidgets",
  "QRubberBand": "QtWidgets",
  "QStyleOptionGraphicsItem": "QtWidgets",
  "QMenuBar": "QtWidgets",
  "QTableView": "QtWidgets",
  "QDesktopWidget": "QtWidgets",
  "QStyleOptionFrameV2": "QtWidgets",
  "QStyleOptionProgressBar": "QtWidgets",
  "QStyleHintReturn": "QtWidgets",
  "QFormLayout": "QtWidgets",
  "QGraphicsSceneHelpEvent": "QtWidgets",
  "QAccessibleTableCornerButton": "QtWidgets",
  "QStyleOptionFrame": "QtWidgets",
  "QStylePlugin": "QtWidgets",
  "QWidgetData": "QtWidgets",
  "QScrollerProperties": "QtWidgets",
  "QProgressBar": "QtWidgets",
  "QStyleOptionDockWidgetV2": "QtWidgets",
  "QWizardPage": "QtWidgets",
  "QGraphicsLayout": "QtWidgets",
  "QStyleOptionComplex": "QtWidgets",
  "QGraphicsEffect": "QtWidgets",
  "QUndoGroup": "QtWidgets",
  "QGraphicsWidget": "QtWidgets",
  "QStyleOptionMenuItem": "QtWidgets",
  "QPushButton": "QtWidgets",
  "QStatusBar": "QtWidgets",
  "QMainWindow": "QtWidgets",
  "QAccessibleTextEdit": "QtWidgets",
  "QLineEdit": "QtWidgets",
  "QDialogButtonBox": "QtWidgets",
  "QGraphicsAnchor": "QtWidgets",
  "QLabel": "QtWidgets",
  "QAccessibleDockWidget": "QtWidgets",
  "QGraphicsSceneEvent": "QtWidgets",
  "QHBoxLayout": "QtWidgets",
  "QGraphicsBlurEffect": "QtWidgets",
  "QPlainTextEdit": "QtWidgets",
  "QStyleOptionFrameV3": "QtWidgets",
  "QAccessibleTableCell": "QtWidgets",
  "QAbstractButton": "QtWidgets",
  "QToolButton": "QtWidgets",
  "QToolBox": "QtWidgets",
  "QMenu": "QtWidgets",
  "QGraphicsScene": "QtWidgets",
  "QAccessibleSlider": "QtWidgets",
  "QSystemTrayIcon": "QtWidgets",
  "QStyleOptionProgressBarV2": "QtWidgets",
  "QAbstractSlider": "QtWidgets",
  "QStackedWidget": "QtWidgets",
  "QSplitterHandle": "QtWidgets",
  "QAbstractGraphicsShapeItem": "QtWidgets",
  "QGroupBox": "QtWidgets",
  "QMouseEventTransition": "QtWidgets",
  "QComboBox": "QtWidgets",
  "QStyleOptionTabWidgetFrame": "QtWidgets",
  "QMacCocoaViewContainer": "QtWidgets",
  "QTapGesture": "QtWidgets",
  "QTextEdit": "QtWidgets",
  "QProxyStyle": "QtWidgets",
  "QGraphicsObject": "QtWidgets",
  "QTableWidgetSelectionRange": "QtWidgets",
  "QItemEditorCreatorBase": "QtWidgets",
  "QAccessibleWindowContainer": "QtWidgets",
  "QTileRules": "QtWidgets",
  "QAccessibleDisplay": "QtWidgets",
  "QAccessibleToolButton": "QtWidgets",
  "QAccessibleToolBox": "QtWidgets",
  "QStyleOptionToolBar": "QtWidgets",
  "QMacNativeWidget": "QtWidgets",
  "QButtonGroup": "QtWidgets",
  "QStyleOptionButton": "QtWidgets",
  "QTextBrowser": "QtWidgets",
  "QCalendarWidget": "QtWidgets",
  "QToolTip": "QtWidgets",
  "QAccessibleLineEdit": "QtWidgets",
  "QDirModel": "QtWidgets",
  "QSlider": "QtWidgets",
  "QStyleOptionTabV2": "QtWidgets",
  "QAccessibleMdiSubWindow": "QtWidgets",
  "QGraphicsGridLayout": "QtWidgets",
  "QKeyEventTransition": "QtWidgets",
  "QSpacerItem": "QtWidgets",
  "QGraphicsSceneDragDropEvent": "QtWidgets",
  "QStyleOptionSizeGrip": "QtWidgets",
  "QFontDialog": "QtWidgets",
  "QAccessiblePlainTextEdit": "QtWidgets",
  "QUndoView": "QtWidgets",
  "QUndoCommand": "QtWidgets",
  "QAccessibleDoubleSpinBox": "QtWidgets",
  "QAccessibleTree": "QtWidgets",
  "QDateTimeEdit": "QtWidgets",
  "QWidget": "QtWidgets",
  "QGraphicsSceneMoveEvent": "QtWidgets",
  "QGraphicsSceneMouseEvent": "QtWidgets",
  "QSplashScreen": "QtWidgets",
  "QAccessibleTextWidget": "QtWidgets",
  "QStyleOptionToolBoxV2": "QtWidgets",
  "QLayoutItem": "QtWidgets",
  "QStackedLayout": "QtWidgets",
  "QGestureRecognizer": "QtWidgets",
  "QCompleter": "QtWidgets",
  "QAccessibleMenuBar": "QtWidgets",
  "QAccessibleGroupBox": "QtWidgets",
  "QOpenGLWidget": "QtWidgets",
  "QFocusFrame": "QtWidgets",
  "QAccessibleScrollBar": "QtWidgets",
  "QStyleFactory": "QtWidgets",
  "QStyleHintReturnMask": "QtWidgets",
  "QAccessibleAbstractSlider": "QtWidgets",
  "QGraphicsPolygonItem": "QtWidgets",
  "QGraphicsTextItem": "QtWidgets",
  "QStyleOptionSpinBox": "QtWidgets",
  "QStyleOptionGroupBox": "QtWidgets",
  "QTreeView": "QtWidgets",
  "QItemEditorCreator": "QtWidgets",
  "QGraphicsTransform": "QtWidgets",
  "QCommandLinkButton": "QtWidgets",
  "QGraphicsSceneResizeEvent": "QtWidgets",
  "QCheckBox": "QtWidgets",
  "QListWidget": "QtWidgets",
  "QGraphicsScale": "QtWidgets",
  "QGraphicsSimpleTextItem": "QtWidgets",
  "QPinchGesture": "QtWidgets",
  "QToolBar": "QtWidgets",
  "QStyleOption": "QtWidgets",
  "QCommonStyle": "QtWidgets",
  "QGraphicsOpacityEffect": "QtWidgets",
  "QGraphicsItemGroup": "QtWidgets",
  "QAccessibleTextBrowser": "QtWidgets",
  "QTabWidget": "QtWidgets",
  "QItemEditorFactory": "QtWidgets",
  "QApplication": "QtWidgets",
  "QGraphicsItem": "QtWidgets",
  "QGraphicsRotation": "QtWidgets",
  "QAbstractScrollArea": "QtWidgets",
  "QAccessibleComboBox": "QtWidgets",
  "QAccessibleButton": "QtWidgets",
  "QGraphicsSceneContextMenuEvent": "QtWidgets",
  "QWidgetItemV2": "QtWidgets",
  "QStyleOptionTabBarBase": "QtWidgets",
  "QDialog": "QtWidgets",
  "QGraphicsRectItem": "QtWidgets",
  "QStyleOptionViewItemV4": "QtWidgets",
  "QLCDNumber": "QtWidgets",
  "QAccessibleMainWindow": "QtWidgets",
  "QGraphicsItemAnimation": "QtWidgets",
  "QAccessibleAbstractScrollArea": "QtWidgets",
  "QStyledItemDelegate": "QtWidgets",
  "QAccessibleSpinBox": "QtWidgets",
  "QStylePainter": "QtWidgets",
  "QGraphicsProxyWidget": "QtWidgets",
  "QWidgetAction": "QtWidgets",
  "QGraphicsLinearLayout": "QtWidgets",
  "QAbstractSpinBox": "QtWidgets",
  "QGraphicsPathItem": "QtWidgets",
  "QProgressDialog": "QtWidgets",
  "QColorDialog": "QtWidgets",
  "QShortcut": "QtWidgets",
  "QDateEdit": "QtWidgets",
  "QMessageBox": "QtWidgets",
  "QAccessibleTableHeaderCell": "QtWidgets",
  "QScrollBar": "QtWidgets",
  "QWidgetItem": "QtWidgets",
  "QDoubleSpinBox": "QtWidgets",
  "QFileIconProvider": "QtWidgets",
  "QAccessibleCalendarWidget": "QtWidgets",
  "QListWidgetItem": "QtWidgets",
  "QStyleOptionViewItemV2": "QtWidgets",
  "QStyleHintReturnVariant": "QtWidgets",
  "QErrorMessage": "QtWidgets",
  "QAbstractItemView": "QtWidgets",
  "QGraphicsPixmapItem": "QtWidgets",
  "QSplitter": "QtWidgets",
  "QAccessibleAbstractSpinBox": "QtWidgets",
  "QTreeWidgetItem": "QtWidgets",
  "QAbstractItemDelegate": "QtWidgets",
  "QGraphicsLayoutItem": "QtWidgets",
  "QDataWidgetMapper": "QtWidgets",
  "QStandardItemEditorCreator": "QtWidgets",
  "QGraphicsDropShadowEffect": "QtWidgets",
  "QTimeEdit": "QtWidgets",
  "QDockWidget": "QtWidgets",
  "QKeySequenceEdit": "QtWidgets",
  "QAccessibleTabBar": "QtWidgets",
  "QTableWidgetItem": "QtWidgets",
  "QStyleOptionViewItemV3": "QtWidgets",
  "QAccessibleWidget": "QtWidgets",
  "QLayout": "QtWidgets",
  "QTreeWidget": "QtWidgets",
  "QStyleOptionSlider": "QtWidgets",
  "QAccessibleMenuItem": "QtWidgets",
  "QWizard": "QtWidgets",
  "QGraphicsSceneWheelEvent": "QtWidgets",
  "QTableWidget": "QtWidgets",
  "QWhatsThis": "QtWidgets",
  "QSizeGrip": "QtWidgets",
  "QTreeWidgetItemIterator": "QtWidgets",
  "QStyleOptionFocusRect": "QtWidgets",
  "QMdiSubWindow": "QtWidgets",
  "QBoxLayout": "QtWidgets",
  "QItemDelegate": "QtWidgets",
  "QStyleOptionTabWidgetFrameV2": "QtWidgets",
  "QListView": "QtWidgets",
  "QAccessibleProgressBar": "QtWidgets",
  "QAccessibleScrollArea": "QtWidgets",
  "QVBoxLayout": "QtWidgets",
  "QStyleOptionTab": "QtWidgets",
  "QStyleOptionDockWidget": "QtWidgets",
  "QAccessibleMdiArea": "QtWidgets",
  "QStyleOptionHeader": "QtWidgets",
  "QAccessibleDial": "QtWidgets",
  "QMdiArea": "QtWidgets",
  "QSwipeGesture": "QtWidgets",
  "QAccessibleStackedWidget": "QtWidgets",
  "QColumnView": "QtWidgets",
  "QGraphicsView": "QtWidgets",
  "QTapAndHoldGesture": "QtWidgets",
  "QGestureEvent": "QtWidgets",
  "QStyleOptionTabV3": "QtWidgets",
  "QGraphicsLineItem": "QtWidgets",
  "QStyleOptionToolBox": "QtWidgets",
  "QStyleOptionViewItem": "QtWidgets",
  "QAccessibleTable": "QtWidgets",
  "QFileDialog": "QtWidgets",
  "QStyleOptionRubberBand": "QtWidgets",
  "QHeaderView": "QtWidgets",
  "QPanGesture": "QtWidgets",
  "QGraphicsColorizeEffect": "QtWidgets",
  "QGraphicsSceneHoverEvent": "QtWidgets",
  "QRadioButton": "QtWidgets",
  "QStyleOptionTitleBar": "QtWidgets",
  "QFileSystemModel": "QtWidgets",
  "QAction": "QtWidgets",
  "QColormap": "QtWidgets",
  "QStyleOptionComboBox": "QtWidgets",
  "QStyleOptionTabBarBaseV2": "QtWidgets",
  "QGraphicsAnchorLayout": "QtWidgets",
  "QActionGroup": "QtWidgets",
  "QStyle": "QtWidgets",
  "QSpinBox": "QtWidgets",
  "QTabBar": "QtWidgets",
  "QGridLayout": "QtWidgets",
  "QSizePolicy": "QtWidgets",
  "QScroller": "QtWidgets",
  "QFontComboBox": "QtWidgets",
  "QStyleOptionToolButton": "QtWidgets",
  "QScrollArea": "QtWidgets",
  "QGraphicsEllipseItem": "QtWidgets",
  "QInputDialog": "QtWidgets",
  "QSerialPort": "QtSerialPort",
  "QSerialPortInfo": "QtSerialPort",
  "QWebEnginePage": "QtWebEngineWidgets",
  "QWebEngineScript": "QtWebEngineWidgets",
  "QWebEngineDownloadItem": "QtWebEngineWidgets",
  "QWebEngineHistory": "QtWebEngineWidgets",
  "QWebEngineCallback": "QtWebEngineWidgets",
  "QWebEngineSettings": "QtWebEngineWidgets",
  "QWebEngineScriptCollection": "QtWebEngineWidgets",
  "QWebEngineCertificateError": "QtWebEngineWidgets",
  "QWebEngineHistoryItem": "QtWebEngineWidgets",
  "QWebEngineView": "QtWebEngineWidgets",
  "QWebEngineProfile": "QtWebEngineWidgets",
  "QGL": "QtOpenGL",
  "QGLWidget": "QtOpenGL",
  "QGLShaderProgram": "QtOpenGL",
  "QGLPixelBuffer": "QtOpenGL",
  "QGLFunctions": "QtOpenGL",
  "QGLFunctionsPrivate": "QtOpenGL",
  "QGLBuffer": "QtOpenGL",
  "QGLFramebufferObject": "QtOpenGL",
  "QGLFramebufferObjectFormat": "QtOpenGL",
  "QGLContext": "QtOpenGL",
  "QGLColormap": "QtOpenGL",
  "QGLFormat": "QtOpenGL",
  "QGLShader": "QtOpenGL",
  "QDesignerComponents": "QtDesigner",
  "QDesignerCustomWidgetInterface": "QtUiPlugin",
  "QDesignerResourceBrowserInterface": "QtDesigner",
  "QDesignerPropertySheetExtension": "QtDesigner",
  "QDesignerMetaDataBaseItemInterface": "QtDesigner",
  "QAbstractFormBuilder": "QtDesigner",
  "QDesignerIntegrationInterface": "QtDesigner",
  "QDesignerWidgetBoxInterface": "QtDesigner",
  "QDesignerDnDItemInterface": "QtDesigner",
  "QDesignerFormWindowToolInterface": "QtDesigner",
  "QDesignerIntegration": "QtDesigner",
  "QDesignerFormWindowCursorInterface": "QtDesigner",
  "QFormBuilder": "QtDesigner",
  "QDesignerDynamicPropertySheetExtension": "QtDesigner",
  "QDesignerWidgetDataBaseInterface": "QtDesigner",
  "QDesignerLanguageExtension": "QtDesigner",
  "QDesignerFormEditorInterface": "QtDesigner",
  "QDesignerExtraInfoExtension": "QtDesigner",
  "QDesignerObjectInspectorInterface": "QtDesigner",
  "QDesignerFormWindowManagerInterface": "QtDesigner",
  "QDesignerTaskMenuExtension": "QtDesigner",
  "QExtensionFactory": "QtDesigner",
  "QDesignerNewFormWidgetInterface": "QtDesigner",
  "QDesignerWidgetFactoryInterface": "QtDesigner",
  "QDesignerSettingsInterface": "QtDesigner",
  "QDesignerPropertyEditorInterface": "QtDesigner",
  "QDesignerMetaDataBaseInterface": "QtDesigner",
  "QDesignerExportWidget": "QtUiPlugin",
  "QDesignerLayoutDecorationExtension": "QtDesigner",
  "QDesignerFormWindowInterface": "QtDesigner",
  "QDesignerCustomWidgetCollectionInterface": "QtUiPlugin",
  "QDesignerPromotionInterface": "QtDesigner",
  "QExtensionManager": "QtDesigner",
  "QDesignerWidgetDataBaseItemInterface": "QtDesigner",
  "QDesignerActionEditorInterface": "QtDesigner",
  "QDesignerFormEditorPluginInterface": "QtDesigner",
  "QDesignerContainerExtension": "QtDesigner",
  "QAbstractExtensionManager": "QtDesigner",
  "QAbstractExtensionFactory": "QtDesigner",
  "QDesignerOptionsPageInterface": "QtDesigner",
  "QDesignerMemberSheetExtension": "QtDesigner",
  "QCullFace": "Qt3DRenderer",
  "QDithering": "Qt3DRenderer",
  "QCylinderMesh": "Qt3DRenderer",
  "QDiffuseSpecularMapMaterial": "Qt3DRenderer",
  "QAbstractTextureProvider": "Qt3DRenderer",
  "QNormalDiffuseMapAlphaMaterial": "Qt3DRenderer",
  "QStencilTest": "Qt3DRenderer",
  "QSceneLoader": "Qt3DRenderer",
  "QCameraSelector": "Qt3DRenderer",
  "QNormalDiffuseSpecularMapMaterial": "Qt3DRenderer",
  "QMaterial": "Qt3DRenderer",
  "QFrameGraphNode": "Qt3DRenderer",
  "QTorusMesh": "Qt3DRenderer",
  "QMesh": "Qt3DRenderer",
  "QAbstractTextureImage": "Qt3DRenderer",
  "QAbstractMeshFunctorPtr": "Qt3DRenderer",
  "QBlendState": "Qt3DRenderer",
  "QColorMask": "Qt3DRenderer",
  "QFrameGraphSelector": "Qt3DRenderer",
  "QAbstractBufferPtr": "Qt3DCore",
  "QShaderData": "Qt3DRenderer",
  "QCuboidMesh": "Qt3DRenderer",
  "QOpenGLFilter": "Qt3DRenderer",
  "QBlendEquation": "Qt3DRenderer",
  "QTextureBuffer": "Qt3DRenderer",
  "QAbstractAttributePtr": "Qt3DRenderer",
  "QRenderTargetSelector": "Qt3DRenderer",
  "QViewport": "Qt3DRenderer",
  "QPolygonOffset": "Qt3DRenderer",
  "QAlphaTest": "Qt3DRenderer",
  "QStateSet": "Qt3DRenderer",
  "QTextureImage": "Qt3DRenderer",
  "QTexture3D": "Qt3DRenderer",
  "QSortCriterion": "Qt3DRenderer",
  "QAbstractMesh": "Qt3DRenderer",
  "QParameterMapping": "Qt3DRenderer",
  "QTexture2DMultisample": "Qt3DRenderer",
  "QPointLight": "Qt3DRenderer",
  "QTextureDataFunctorPtr": "Qt3DRenderer",
  "QTexture2D": "Qt3DRenderer",
  "QAbstractLight": "Qt3DRenderer",
  "QShaderProgram": "Qt3DRenderer",
  "QAlphaCoverage": "Qt3DRenderer",
  "QAbstractMeshFunctor": "Qt3DRenderer",
  "QFrameGraphSelectorFunctor": "Qt3DRenderer",
  "QLayer": "Qt3DRenderer",
  "QEffect": "Qt3DRenderer",
  "QFrameGraphSelectorFunctorPtr": "Qt3DRenderer",
  "QBlendStateSeparate": "Qt3DRenderer",
  "QLayerFilter": "Qt3DRenderer",
  "QTextureWrapMode": "Qt3DRenderer",
  "QSpotLight": "Qt3DRenderer",
  "QNormalDiffuseMapMaterial": "Qt3DRenderer",
  "QSortMethod": "Qt3DRenderer",
  "QDepthTest": "Qt3DRenderer",
  "QScissorTest": "Qt3DRenderer",
  "QItemModelBuffer": "Qt3DRenderer",
  "QTextureRectangle": "Qt3DRenderer",
  "QTexture1D": "Qt3DRenderer",
  "QDepthMask": "Qt3DRenderer",
  "QRenderPassFilter": "Qt3DRenderer",
  "QTechnique": "Qt3DRenderer",
  "QPhongMaterial": "Qt3DRenderer",
  "QMeshData": "Qt3DRenderer",
  "QDiffuseMapMaterial": "Qt3DRenderer",
  "QRenderAspect": "Qt3DRenderer",
  "QTexture2DArray": "Qt3DRenderer",
  "QTexture1DArray": "Qt3DRenderer",
  "QPlaneMesh": "Qt3DRenderer",
  "QRenderPass": "Qt3DRenderer",
  "QForwardRenderer": "Qt3DRenderer",
  "QAnnotation": "Qt3DRenderer",
  "QTextureCubeMap": "Qt3DRenderer",
  "QNoDraw": "Qt3DRenderer",
  "QSphereMesh": "Qt3DRenderer",
  "QMeshDataPtr": "Qt3DRenderer",
  "QSkyboxEntity": "Qt3DRenderer",
  "QRenderTarget": "Qt3DRenderer",
  "QTextureCubeMapArray": "Qt3DRenderer",
  "QTechniqueFilter": "Qt3DRenderer",
  "QTexture": "Qt3DRenderer",
  "QDirectionalLight": "Qt3DRenderer",
  "QParameter": "Qt3DRenderer",
  "QFrameGraph": "Qt3DRenderer",
  "QAbstractSceneLoader": "Qt3DRenderer",
  "QClearBuffer": "Qt3DRenderer",
  "QRenderAttachment": "Qt3DRenderer",
  "QPerVertexColorMaterial": "Qt3DRenderer",
  "QRenderState": "Qt3DRenderer",
  "QFrontFace": "Qt3DRenderer",
  "QTextureDataFunctor": "Qt3DRenderer",
  "QTexture2DMultisampleArray": "Qt3DRenderer",
  "QWebFrame": "QtWebKitWidgets",
  "QWebInspector": "QtWebKitWidgets",
  "QWebPage": "QtWebKitWidgets",
  "QWebHitTestResult": "QtWebKitWidgets",
  "QGraphicsWebView": "QtWebKitWidgets",
  "QWebView": "QtWebKitWidgets",
  "QDBusVirtualObject": "QtDBus",
  "QDBusAbstractAdaptor": "QtDBus",
  "QDBusArgument": "QtDBus",
  "QDBusPendingReply": "QtDBus",
  "QDBusServer": "QtDBus",
  "QDBusMetaType": "QtDBus",
  "QDBusPendingCall": "QtDBus",
  "QDBusConnection": "QtDBus",
  "QDBusServiceWatcher": "QtDBus",
  "QDBusUnixFileDescriptor": "QtDBus",
  "QDBusVariant": "QtDBus",
  "QDBusMessage": "QtDBus",
  "QDBusInterface": "QtDBus",
  "QDBusReply": "QtDBus",
  "QDBusAbstractInterface": "QtDBus",
  "QDBusContext": "QtDBus",
  "QDBusSignature": "QtDBus",
  "QDBusPendingCallWatcher": "QtDBus",
  "QDBusError": "QtDBus",
  "QDBusConnectionInterface": "QtDBus",
  "QDBusPendingReplyData": "QtDBus",
  "QDBusAbstractInterfaceBase": "QtDBus",
  "QDBusObjectPath": "QtDBus",
  "QOpenGLExtensions": "QtOpenGLExtensions",
  "QXmlNodeModelIndex": "QtXmlPatterns",
  "QXmlSerializer": "QtXmlPatterns",
  "QAbstractXmlReceiver": "QtXmlPatterns",
  "QXmlItem": "QtXmlPatterns",
  "QXmlSchema": "QtXmlPatterns",
  "QXmlName": "QtXmlPatterns",
  "QAbstractUriResolver": "QtXmlPatterns",
  "QSimpleXmlNodeModel": "QtXmlPatterns",
  "QXmlQuery": "QtXmlPatterns",
  "QXmlFormatter": "QtXmlPatterns",
  "QXmlResultItems": "QtXmlPatterns",
  "QXmlNamePool": "QtXmlPatterns",
  "QAbstractXmlNodeModel": "QtXmlPatterns",
  "QSourceLocation": "QtXmlPatterns",
  "QXmlSchemaValidator": "QtXmlPatterns",
  "QAbstractMessageHandler": "QtXmlPatterns",
  "QSqlResult": "QtSql",
  "QSqlDriver": "QtSql",
  "QSqlDatabase": "QtSql",
  "QSqlIndex": "QtSql",
  "QSqlRelationalTableModel": "QtSql",
  "QSqlRelation": "QtSql",
  "QSqlDriverCreator": "QtSql",
  "QSqlDriverCreatorBase": "QtSql",
  "QSql": "QtSql",
  "QSqlTableModel": "QtSql",
  "QSqlQueryModel": "QtSql",
  "QSqlDriverPlugin": "QtSql",
  "QSqlQuery": "QtSql",
  "QSqlRecord": "QtSql",
  "QSqlField": "QtSql",
  "QSqlRelationalDelegate": "QtSql",
  "QSqlError": "QtSql",
  "QSsl": "QtNetwork",
  "QNetworkConfigurationManager": "QtNetwork",
  "QNetworkReply": "QtNetwork",
  "QSslPreSharedKeyAuthenticator": "QtNetwork",
  "QNetworkInterface": "QtNetwork",
  "QDnsDomainNameRecord": "QtNetwork",
  "QSslCertificate": "QtNetwork",
  "QNetworkRequest": "QtNetwork",
  "QLocalServer": "QtNetwork",
  "QHttpMultiPart": "QtNetwork",
  "QTcpServer": "QtNetwork",
  "QHostInfo": "QtNetwork",
  "QSslConfiguration": "QtNetwork",
  "QNetworkCookie": "QtNetwork",
  "QNetworkSession": "QtNetwork",
  "QSslError": "QtNetwork",
  "QSslKey": "QtNetwork",
  "QAbstractSocket": "QtNetwork",
  "QDnsHostAddressRecord": "QtNetwork",
  "QDnsMailExchangeRecord": "QtNetwork",
  "QNetworkProxyFactory": "QtNetwork",
  "QNetworkCacheMetaData": "QtNetwork",
  "QDnsTextRecord": "QtNetwork",
  "QHostAddress": "QtNetwork",
  "QDnsLookup": "QtNetwork",
  "QSslSocket": "QtNetwork",
  "QSslEllipticCurve": "QtNetwork",
  "QUdpSocket": "QtNetwork",
  "QLocalSocket": "QtNetwork",
  "QNetworkDiskCache": "QtNetwork",
  "QHttpPart": "QtNetwork",
  "QNetworkProxy": "QtNetwork",
  "QNetworkAddressEntry": "QtNetwork",
  "QAuthenticator": "QtNetwork",
  "QSslCertificateExtension": "QtNetwork",
  "QIPv6Address": "QtNetwork",
  "QTcpSocket": "QtNetwork",
  "QNetworkAccessManager": "QtNetwork",
  "QNetworkProxyQuery": "QtNetwork",
  "QDnsServiceRecord": "QtNetwork",
  "QNetworkConfiguration": "QtNetwork",
  "QSslCipher": "QtNetwork",
  "QAbstractNetworkCache": "QtNetwork",
  "QNetworkCookieJar": "QtNetwork",
  "QQuickWidget": "QtQuickWidgets",
  "QScriptValue": "QtScript",
  "QScriptExtensionPlugin": "QtScript",
  "QScriptValueList": "QtScript",
  "QScriptSyntaxCheckResult": "QtScript",
  "QScriptClassPropertyIterator": "QtScript",
  "QScriptClass": "QtScript",
  "QScriptEngineAgent": "QtScript",
  "QScriptable": "QtScript",
  "QScriptExtensionInterface": "QtScript",
  "QScriptContextInfo": "QtScript",
  "QScriptValueIterator": "QtScript",
  "QScriptContextInfoList": "QtScript",
  "QScriptContext": "QtScript",
  "QScriptProgram": "QtScript",
  "QScriptEngine": "QtScript",
  "QScriptString": "QtScript",
  "QKeyboardInput": "Qt3DInput",
  "QKeyboardController": "Qt3DInput",
  "QInputAspect": "Qt3DInput",
  "QNearFieldTarget": "QtNfc",
  "QNdefNfcIconRecord": "QtNfc",
  "QNearFieldManager": "QtNfc",
  "QNdefMessage": "QtNfc",
  "QNdefNfcUriRecord": "QtNfc",
  "QNearFieldShareManager": "QtNfc",
  "QNdefFilter": "QtNfc",
  "QQmlNdefRecord": "QtNfc",
  "QNdefNfcTextRecord": "QtNfc",
  "QNdefNfcSmartPosterRecord": "QtNfc",
  "QNearFieldShareTarget": "QtNfc",
  "QNdefRecord": "QtNfc",
  "QX11Info": "QtX11Extras",
  "QWebSocketServer": "QtWebSockets",
  "QWebSocket": "QtWebSockets",
  "QWebSocketCorsAuthenticator": "QtWebSockets",
  "QMaskGenerator": "QtWebSockets",
  "QDeclarativeProperties": "QtDeclarative",
  "QDeclarativePropertyValueSource": "QtDeclarative",
  "QDeclarativeExpression": "QtDeclarative",
  "QDeclarativeTypeInfo": "QtDeclarative",
  "QDeclarativeEngine": "QtDeclarative",
  "QDeclarativeError": "QtDeclarative",
  "QDeclarativeItem": "QtDeclarative",
  "QDeclarativeNetworkAccessManagerFactory": "QtDeclarative",
  "QDeclarativeExtensionInterface": "QtDeclarative",
  "QDeclarativeComponent": "QtDeclarative",
  "QDeclarativeListProperty": "QtDeclarative",
  "QDeclarativeContext": "QtDeclarative",
  "QDeclarativeListReference": "QtDeclarative",
  "QDeclarativeImageProvider": "QtDeclarative",
  "QDeclarativeInfo": "QtDeclarative",
  "QDeclarativeParserStatus": "QtDeclarative",
  "QDeclarativeView": "QtDeclarative",
  "QDeclarativeProperty": "QtDeclarative",
  "QDeclarativeExtensionPlugin": "QtDeclarative",
  "QDeclarativeDebuggingEnabler": "QtDeclarative",
  "QDeclarativeScriptString": "QtDeclarative",
  "QDeclarativePropertyValueInterceptor": "QtDeclarative",
  "QDeclarativePropertyMap": "QtDeclarative",
  "QDeclarativeAttachedPropertiesFunc": "QtDeclarative",
  "QPrintDialog": "QtPrintSupport",
  "QPrintPreviewDialog": "QtPrintSupport",
  "QPrinterInfo": "QtPrintSupport",
  "QPageSetupDialog": "QtPrintSupport",
  "QAbstractPrintDialog": "QtPrintSupport",
  "QPrintEngine": "QtPrintSupport",
  "QPrintPreviewWidget": "QtPrintSupport",
  "QPrinter": "QtPrintSupport",
  "QBluetoothHostInfo": "QtBluetooth",
  "QBluetoothTransferManager": "QtBluetooth",
  "QBluetoothAddress": "QtBluetooth",
  "QLowEnergyDescriptor": "QtBluetooth",
  "QBluetoothServer": "QtBluetooth",
  "QBluetoothTransferRequest": "QtBluetooth",
  "QLowEnergyController": "QtBluetooth",
  "QBluetoothTransferReply": "QtBluetooth",
  "QBluetoothServiceInfo": "QtBluetooth",
  "QBluetoothLocalDevice": "QtBluetooth",
  "QBluetoothDeviceInfo": "QtBluetooth",
  "QLowEnergyHandle": "QtBluetooth",
  "QLowEnergyCharacteristic": "QtBluetooth",
  "QBluetoothSocket": "QtBluetooth",
  "QBluetoothDeviceDiscoveryAgent": "QtBluetooth",
  "QBluetoothUuid": "QtBluetooth",
  "QLowEnergyService": "QtBluetooth",
  "QBluetoothServiceDiscoveryAgent": "QtBluetooth",
  "QSGSimpleMaterialComparableMaterial": "QtQuick",
  "QQuickPaintedItem": "QtQuick",
  "QQuickItem": "QtQuick",
  "QSGOpacityNode": "QtQuick",
  "QSGOpaqueTextureMaterial": "QtQuick",
  "QQuickRenderControl": "QtQuick",
  "QSGGeometryNode": "QtQuick",
  "QSGAbstractRenderer": "QtQuick",
  "QQuickTextDocument": "QtQuick",
  "QSGTextureProvider": "QtQuick",
  "QSGSimpleTextureNode": "QtQuick",
  "QSGFlatColorMaterial": "QtQuick",
  "QSGMaterialShader": "QtQuick",
  "QSGClipNode": "QtQuick",
  "QQuickTransform": "QtQuick",
  "QQuickWindow": "QtQuick",
  "QSGTexture": "QtQuick",
  "QSGSimpleMaterial": "QtQuick",
  "QSGNode": "QtQuick",
  "QSGTextureMaterial": "QtQuick",
  "QSGVertexColorMaterial": "QtQuick",
  "QSGMaterial": "QtQuick",
  "QSGEngine": "QtQuick",
  "QSGRootNode": "QtQuick",
  "QSGDynamicTexture": "QtQuick",
  "QSGTransformNode": "QtQuick",
  "QQuickImageProvider": "QtQuick",
  "QQuickTextureFactory": "QtQuick",
  "QSGGeometry": "QtQuick",
  "QQuickItemGrabResult": "QtQuick",
  "QQuickFramebufferObject": "QtQuick",
  "QSGNodeVisitor": "QtQuick",
  "QQuickView": "QtQuick",
  "QSGSimpleRectNode": "QtQuick",
  "QSGMaterialType": "QtQuick",
  "QSGBasicGeometryNode": "QtQuick",
  "QSGSimpleMaterialShader": "QtQuick",
  "QPlaceIcon": "QtLocation",
  "QPlaceManagerEngine": "QtLocation",
  "QPlace": "QtLocation",
  "QGeoRoutingManager": "QtLocation",
  "QGeoCodingManager": "QtLocation",
  "QGeoManeuver": "QtLocation",
  "QPlaceProposedSearchResult": "QtLocation",
  "QPlaceContentReply": "QtLocation",
  "QGeoRoute": "QtLocation",
  "QPlaceSearchRequest": "QtLocation",
  "QGeoCodingManagerEngine": "QtLocation",
  "QPlaceEditorial": "QtLocation",
  "QPlaceImage": "QtLocation",
  "QGeoRoutingManagerEngine": "QtLocation",
  "QGeoServiceProviderFactory": "QtLocation",
  "QGeoCodeReply": "QtLocation",
  "QGeoRouteSegment": "QtLocation",
  "QGeoServiceProvider": "QtLocation",
  "QLocation": "QtLocation",
  "QGeoRouteRequest": "QtLocation",
  "QPlaceMatchReply": "QtLocation",
  "QPlaceDetailsReply": "QtLocation",
  "QPlaceIdReply": "QtLocation",
  "QPlaceCategory": "QtLocation",
  "QGeoRouteReply": "QtLocation",
  "QPlaceReply": "QtLocation",
  "QPlaceMatchRequest": "QtLocation",
  "QPlaceSearchReply": "QtLocation",
  "QPlaceSearchSuggestionReply": "QtLocation",
  "QPlaceContactDetail": "QtLocation",
  "QPlaceUser": "QtLocation",
  "QPlaceContentRequest": "QtLocation",
  "QPlaceAttribute": "QtLocation",
  "QPlaceSupplier": "QtLocation",
  "QPlaceSearchResult": "QtLocation",
  "QPlaceManager": "QtLocation",
  "QPlaceResult": "QtLocation",
  "QPlaceContent": "QtLocation",
  "QPlaceRatings": "QtLocation",
  "QPlaceReview": "QtLocation",
  "QScriptEngineDebugger": "QtScriptTools",
  "QVector3D": "QtGui",
  "QOpenGLFunctions_2_1": "QtGui",
  "QPen": "QtGui",
  "QAccessible": "QtGui",
  "QMouseEvent": "QtGui",
  "QTextItem": "QtGui",
  "QFont": "QtGui",
  "QOpenGLBuffer": "QtGui",
  "QImageWriter": "QtGui",
  "QWidgetList": "QtGui",
  "QBrush": "QtGui",
  "QDragEnterEvent": "QtGui",
  "QRawFont": "QtGui",
  "QPicture": "QtGui",
  "QTextFragment": "QtGui",
  "QSurfaceFormat": "QtGui",
  "QAbstractTextDocumentLayout": "QtGui",
  "QMatrix2x4": "QtGui",
  "QAccessibleValueInterface": "QtGui",
  "QGlyphRun": "QtGui",
  "QAccessibleTableCellInterface": "QtGui",
  "QPaintDevice": "QtGui",
  "QCursor": "QtGui",
  "QGenericMatrix": "QtGui",
  "QToolBarChangeEvent": "QtGui",
  "QTextImageFormat": "QtGui",
  "QAccessibleBridge": "QtGui",
  "QOpenGLFunctions_3_3_Core": "QtGui",
  "QOpenGLShaderProgram": "QtGui",
  "QTextDocument": "QtGui",
  "QFontMetricsF": "QtGui",
  "QCloseEvent": "QtGui",
  "QInputMethodEvent": "QtGui",
  "QAbstractUndoItem": "QtGui",
  "QOpenGLContext": "QtGui",
  "QHoverEvent": "QtGui",
  "QOpenGLFunctions_ES2": "QtGui",
  "QFontDatabase": "QtGui",
  "QWindowStateChangeEvent": "QtGui",
  "QScrollPrepareEvent": "QtGui",
  "QAccessibleTextCursorEvent": "QtGui",
  "QTextCharFormat": "QtGui",
  "QWhatsThisClickedEvent": "QtGui",
  "QAccessibleTextSelectionEvent": "QtGui",
  "QPolygon": "QtGui",
  "QBrushData": "QtGui",
  "QContextMenuEvent": "QtGui",
  "QTextBlockUserData": "QtGui",
  "QOpenGLWindow": "QtGui",
  "QAccessibleTableModelChangeEvent": "QtGui",
  "QBackingStore": "QtGui",
  "QFontInfo": "QtGui",
  "QMatrix2x2": "QtGui",
  "QAccessibleValueChangeEvent": "QtGui",
  "QTextDocumentWriter": "QtGui",
  "QImageCleanupFunction": "QtGui",
  "QOpenGLFunctions_1_0": "QtGui",
  "QPaintEngineState": "QtGui",
  "QMovie": "QtGui",
  "QSyntaxHighlighter": "QtGui",
  "QAccessibleTextInsertEvent": "QtGui",
  "QOpenGLFunctions_4_2_Compatibility": "QtGui",
  "QTouchEvent": "QtGui",
  "QOpenGLTimeMonitor": "QtGui",
  "QTextTableFormat": "QtGui",
  "QShortcutEvent": "QtGui",
  "QOpenGLFunctions_3_2_Core": "QtGui",
  "QHelpEvent": "QtGui",
  "QTextInlineObject": "QtGui",
  "QConicalGradient": "QtGui",
  "QOpenGLPixelTransferOptions": "QtGui",
  "QTabletEvent": "QtGui",
  "QTransform": "Qt3DCore",
  "QInputMethod": "QtGui",
  "QFileOpenEvent": "QtGui",
  "QDoubleValidator": "QtGui",
  "QPictureFormatPlugin": "QtGui",
  "QOpenGLFunctions_4_3_Core": "QtGui",
  "QAccessibleTextUpdateEvent": "QtGui",
  "QMatrix2x3": "QtGui",
  "QDragLeaveEvent": "QtGui",
  "QOpenGLFramebufferObjectFormat": "QtGui",
  "QRadialGradient": "QtGui",
  "QPaintEngine": "QtGui",
  "QKeySequence": "QtGui",
  "QOpenGLFunctions_1_2": "QtGui",
  "QImageIOHandler": "QtGui",
  "QAccessibleApplication": "QtGui",
  "QWidgetSet": "QtGui",
  "QFocusEvent": "QtGui",
  "QPainterPathStroker": "QtGui",
  "QImageReader": "QtGui",
  "QImage": "QtGui",
  "QOpenGLFunctions": "QtGui",
  "QTextLength": "QtGui",
  "QEnterEvent": "QtGui",
  "QAccessiblePlugin": "QtGui",
  "QTextFrame": "QtGui",
  "QQuaternion": "QtGui",
  "QWheelEvent": "QtGui",
  "QMoveEvent": "QtGui",
  "QOpenGLVersionFunctions": "QtGui",
  "QOpenGLFunctions_1_1": "QtGui",
  "QIcon": "QtGui",
  "QGradientStops": "QtGui",
  "QAccessibleTextInterface": "QtGui",
  "QOpenGLDebugLogger": "QtGui",
  "QScreen": "QtGui",
  "QPageSize": "QtGui",
  "QOpenGLFunctions_1_4": "QtGui",
  "QTextObject": "QtGui",
  "QValidator": "QtGui",
  "QFontMetrics": "QtGui",
  "QDesktopServices": "QtGui",
  "QHideEvent": "QtGui",
  "QOpenGLFunctions_4_5_Core": "QtGui",
  "QAccessibleTableInterface": "QtGui",
  "QOpenGLFramebufferObject": "QtGui",
  "QOpenGLVersionProfile": "QtGui",
  "QIconEngineV2": "QtGui",
  "QTextBlockFormat": "QtGui",
  "QMatrix": "QtGui",
  "QOpenGLFunctions_2_0": "QtGui",
  "QNativeGestureEvent": "QtGui",
  "QGenericPlugin": "QtGui",
  "QDrag": "QtGui",
  "QAccessibleStateChangeEvent": "QtGui",
  "QTextListFormat": "QtGui",
  "QPolygonF": "QtGui",
  "QIntValidator": "QtGui",
  "QTextLayout": "QtGui",
  "QPageLayout": "QtGui",
  "QPdfWriter": "QtGui",
  "QAccessibleObject": "QtGui",
  "QDropEvent": "QtGui",
  "QBitmap": "QtGui",
  "QMatrix4x4": "QtGui",
  "QStandardItemModel": "QtGui",
  "QPixmap": "QtGui",
  "QTextObjectInterface": "QtGui",
  "QWidgetMapper": "QtGui",
  "QWindowList": "QtGui",
  "QTextTableCell": "QtGui",
  "QIconEnginePlugin": "QtGui",
  "QResizeEvent": "QtGui",
  "QOpenGLFunctions_4_4_Core": "QtGui",
  "QMatrix3x2": "QtGui",
  "QVector2D": "QtGui",
  "QAccessibleEvent": "QtGui",
  "QAccessibleTextRemoveEvent": "QtGui",
  "QImageTextKeyLang": "QtGui",
  "QClipboard": "QtGui",
  "QOpenGLShader": "QtGui",
  "QOpenGLFunctions_3_1": "QtGui",
  "QAccessibleEditableTextInterface": "QtGui",
  "QPaintDeviceWindow": "QtGui",
  "QGradient": "QtGui",
  "QGenericPluginFactory": "QtGui",
  "QRegExpValidator": "QtGui",
  "QPaintEvent": "QtGui",
  "QRgb": "QtGui",
  "QOpenGLFunctions_4_2_Core": "QtGui",
  "QScreenOrientationChangeEvent": "QtGui",
  "QMatrix4x3": "QtGui",
  "QOpenGLTexture": "QtGui",
  "QOpenGLFunctions_3_0": "QtGui",
  "QAccessibleInterface": "QtGui",
  "QTextFrameLayoutData": "QtGui",
  "QStyleHints": "QtGui",
  "QTextList": "QtGui",
  "QRasterWindow": "QtGui",
  "QAccessibleBridgePlugin": "QtGui",
  "QPixmapCache": "QtGui",
  "QTextFormat": "QtGui",
  "QSessionManager": "QtGui",
  "QMatrix3x4": "QtGui",
  "QIconDragEvent": "QtGui",
  "QInputEvent": "QtGui",
  "QOpenGLFunctions_4_3_Compatibility": "QtGui",
  "QInputMethodQueryEvent": "QtGui",
  "QDragMoveEvent": "QtGui",
  "QOffscreenSurface": "QtGui",
  "QColor": "QtGui",
  "QPixelFormat": "QtGui",
  "QTextOption": "QtGui",
  "QPlatformSurfaceEvent": "QtGui",
  "QOpenGLFunctions_1_3": "QtGui",
  "QOpenGLContextGroup": "QtGui",
  "QOpenGLFunctions_3_3_Compatibility": "QtGui",
  "QScrollEvent": "QtGui",
  "QOpenGLFunctions_4_1_Compatibility": "QtGui",
  "QOpenGLFunctions_4_5_Compatibility": "QtGui",
  "QOpenGLFunctions_4_4_Compatibility": "QtGui",
  "QGradientStop": "QtGui",
  "QAccessibleActionInterface": "QtGui",
  "QMatrix3x3": "QtGui",
  "QAccessibleImageInterface": "QtGui",
  "QActionEvent": "QtGui",
  "QSurface": "QtGui",
  "QKeyEvent": "QtGui",
  "QOpenGLTimerQuery": "QtGui",
  "QShowEvent": "QtGui",
  "QRegularExpressionValidator": "QtGui",
  "QGuiApplication": "QtGui",
  "QExposeEvent": "QtGui",
  "QIconEngine": "QtGui",
  "QStatusTipEvent": "QtGui",
  "QTextLine": "QtGui",
  "QPainterPath": "QtGui",
  "QOpenGLFunctions_1_5": "QtGui",
  "QWindow": "QtGui",
  "QOpenGLFunctionsPrivate": "QtGui",
  "QOpenGLFunctions_4_0_Compatibility": "QtGui",
  "QOpenGLFunctions_4_1_Core": "QtGui",
  "QTextCursor": "QtGui",
  "QTextTable": "QtGui",
  "QPagedPaintDevice": "QtGui",
  "QStandardItem": "QtGui",
  "QTextBlock": "QtGui",
  "QTouchDevice": "QtGui",
  "QPictureIO": "QtGui",
  "QTextFrameFormat": "QtGui",
  "QOpenGLVertexArrayObject": "QtGui",
  "QOpenGLFunctions_4_0_Core": "QtGui",
  "QStaticText": "QtGui",
  "QTextBlockGroup": "QtGui",
  "QRegion": "QtGui",
  "QApplicationStateChangeEvent": "QtGui",
  "QOpenGLPaintDevice": "QtGui",
  "QImageIOPlugin": "QtGui",
  "QLinearGradient": "QtGui",
  "QOpenGLFunctions_3_2_Compatibility": "QtGui",
  "QPainter": "QtGui",
  "QOpenGLDebugMessage": "QtGui",
  "QVector4D": "QtGui",
  "QMatrix4x2": "QtGui",
  "QTextTableCellFormat": "QtGui",
  "QPalette": "QtGui",
  "QTextDocumentFragment": "QtGui",
  "QWebNotificationData": "QtWebKit",
  "QWebSecurityOrigin": "QtWebKit",
  "QWebElement": "QtWebKit",
  "QWebHistory": "QtWebKit",
  "QWebElementCollection": "QtWebKit",
  "QWebPluginFactory": "QtWebKit",
  "QWebHistoryInterface": "QtWebKit",
  "QWebSpellChecker": "QtWebKit",
  "QWebSettings": "QtWebKit",
  "QWebHapticFeedbackPlayer": "QtWebKit",
  "QWebHistoryItem": "QtWebKit",
  "QWebSelectData": "QtWebKit",
  "QWebNotificationPresenter": "QtWebKit",
  "QWebSelectMethod": "QtWebKit",
  "QWebKitPlatformPlugin": "QtWebKit",
  "QWebTouchModifier": "QtWebKit",
  "QWebDatabase": "QtWebKit",
  "QWebFullScreenVideoHandler": "QtWebKit",
  "QQuickWebView": "QtWebView",
  "QQuickWebViewLoadRequest": "QtWebView",
  "QUiLoader": "QtUiTools",
  "QQmlAspectEngine": "Qt3DQuick",
  "QCamera": "QtMultimedia",
  "QObservableList": "Qt3DCore",
  "QBackendNodeFunctorPtr": "Qt3DCore",
  "QHandle": "Qt3DCore",
  "QScenePropertyChange": "Qt3DCore",
  "QHandleManager": "Qt3DCore",
  "QSceneObserverInterface": "Qt3DCore",
  "QAbstractAttribute": "Qt3DCore",
  "QAspectJobPtr": "Qt3DCore",
  "QLookAtTransform": "Qt3DCore",
  "QSceneInterface": "Qt3DCore",
  "QBackendNodeFunctor": "Qt3DCore",
  "QMatrixTransform": "Qt3DCore",
  "QAbstractBuffer": "Qt3DCore",
  "QNodeList": "Qt3DCore",
  "QOpenGLInformationService": "Qt3DCore",
  "QCameraLens": "Qt3DCore",
  "QRotateTransform": "Qt3DCore",
  "QSceneChangePtr": "Qt3DCore",
  "QEntity": "Qt3DCore",
  "QScaleTransform": "Qt3DCore",
  "QAbstractTransform": "Qt3DCore",
  "QRay3D": "Qt3DCore",
  "QBackendScenePropertyChangePtr": "Qt3DCore",
  "QNodeVisitor": "Qt3DCore",
  "QAspectJob": "Qt3DCore",
  "QAspectJobProviderInterface": "Qt3DCore",
  "QNodeId": "Qt3DCore",
  "QAbstractServiceProvider": "Qt3DCore",
  "QComponent": "Qt3DCore",
  "QAspectEngine": "Qt3DCore",
  "QScene": "Qt3DCore",
  "QNode": "Qt3DCore",
  "QComponentList": "Qt3DCore",
  "QTranslateTransform": "Qt3DCore",
  "QBackendNodeFactory": "Qt3DCore",
  "QScenePropertyChangePtr": "Qt3DCore",
  "QAxisAlignedBoundingBox": "Qt3DCore",
  "QServiceLocator": "Qt3DCore",
  "QBackendScenePropertyChange": "Qt3DCore",
  "QAspectThread": "Qt3DCore",
  "QNodePtr": "Qt3DCore",
  "QBackendNode": "Qt3DCore",
  "QSceneChange": "Qt3DCore",
  "QAbstractAspect": "Qt3DCore",
  "QSystemInformationService": "Qt3DCore",
  "QAspectFactory": "Qt3DCore",
  "QFrameAllocator": "Qt3DCore",
  "QQmlInfo": "QtQml",
  "QQmlExpression": "QtQml",
  "QQmlIncubationController": "QtQml",
  "QJSValue": "QtQml",
  "QQmlNetworkAccessManagerFactory": "QtQml",
  "QQmlContext": "QtQml",
  "QQmlIncubator": "QtQml",
  "QQmlExtensionInterface": "QtQml",
  "QJSValueList": "QtQml",
  "QQmlDebuggingEnabler": "QtQml",
  "QQmlApplicationEngine": "QtQml",
  "QQmlTypeInfo": "QtQml",
  "QQmlPropertyValueSource": "QtQml",
  "QQmlFileSelector": "QtQml",
  "QJSEngine": "QtQml",
  "QQmlEngine": "QtQml",
  "QQmlAttachedPropertiesFunc": "QtQml",
  "QQmlListProperty": "QtQml",
  "QQmlScriptString": "QtQml",
  "QQmlImageProviderBase": "QtQml",
  "QQmlProperty": "QtQml",
  "QQmlComponent": "QtQml",
  "QQmlError": "QtQml",
  "QQmlFile": "QtQml",
  "QJSValueIterator": "QtQml",
  "QQmlListReference": "QtQml",
  "QQmlAbstractUrlInterceptor": "QtQml",
  "QQmlExtensionPlugin": "QtQml",
  "QQmlPropertyMap": "QtQml",
  "QQmlTypesExtensionInterface": "QtQml",
  "QQmlProperties": "QtQml",
  "QQmlParserStatus": "QtQml",
  "QDomNode": "QtXml",
  "QDomCDATASection": "QtXml",
  "QDomProcessingInstruction": "QtXml",
  "QXmlContentHandler": "QtXml",
  "QXmlSimpleReader": "QtXml",
  "QDomNamedNodeMap": "QtXml",
  "QDomNotation": "QtXml",
  "QXmlLexicalHandler": "QtXml",
  "QDomDocument": "QtXml",
  "QDomImplementation": "QtXml",
  "QDomText": "QtXml",
  "QDomDocumentType": "QtXml",
  "QDomCharacterData": "QtXml",
  "QXmlAttributes": "QtXml",
  "QXmlErrorHandler": "QtXml",
  "QXmlNamespaceSupport": "QtXml",
  "QXmlLocator": "QtXml",
  "QXmlEntityResolver": "QtXml",
  "QDomEntityReference": "QtXml",
  "QDomElement": "QtXml",
  "QDomDocumentFragment": "QtXml",
  "QDomComment": "QtXml",
  "QXmlDTDHandler": "QtXml",
  "QDomAttr": "QtXml",
  "QXmlReader": "QtXml",
  "QXmlDefaultHandler": "QtXml",
  "QXmlParseException": "QtXml",
  "QXmlDeclHandler": "QtXml",
  "QXmlInputSource": "QtXml",
  "QDomEntity": "QtXml",
  "QDomNodeList": "QtXml",
  "QEventSizeOfChecker": "QtTest",
  "QTestData": "QtTest",
  "QTestEventLoop": "QtTest",
  "QTestKeyClicksEvent": "QtTest",
  "QTest": "QtTest",
  "QTestEvent": "QtTest",
  "QTestEventList": "QtTest",
  "QSpontaneKeyEvent": "QtTest",
  "QTestDelayEvent": "QtTest",
  "QTestAccessibility": "QtTest",
  "QSignalSpy": "QtTest",
  "QTestMouseEvent": "QtTest",
  "QTestKeyEvent": "QtTest",
  "QGraphicsVideoItem": "QtMultimediaWidgets",
  "QVideoWidget": "QtMultimediaWidgets",
  "QVideoWidgetControl": "QtMultimediaWidgets",
  "QCameraViewfinder": "QtMultimediaWidgets",
  "QSGVideoNode_RGB": "QtMultimediaQuick_p",
  "QSGVideoNodeFactory_Texture": "QtMultimediaQuick_p",
  "QSGVideoNode_Texture": "QtMultimediaQuick_p",
  "QSGVideoNodeFactory_RGB": "QtMultimediaQuick_p",
  "QSGVideoNode_YUV": "QtMultimediaQuick_p",
  "QSGVideoNodeFactory_YUV": "QtMultimediaQuick_p",
  "QQmlWebChannel": "QtWebChannel",
  "QWebChannelAbstractTransport": "QtWebChannel",
  "QWebChannel": "QtWebChannel",
  "QSvgGenerator": "QtSvg",
  "QSvgRenderer": "QtSvg",
  "QGraphicsSvgItem": "QtSvg",
  "QSvgWidget": "QtSvg",
  "QHelpContentModel": "QtHelp",
  "QHelpSearchResultWidget": "QtHelp",
  "QHelpSearchQueryWidget": "QtHelp",
  "QHelpSearchEngine": "QtHelp",
  "QHelpEngine": "QtHelp",
  "QHelpContentWidget": "QtHelp",
  "QHelpEngineCore": "QtHelp",
  "QHelpSearchQuery": "QtHelp",
  "QHelpContentItem": "QtHelp",
  "QHelpIndexModel": "QtHelp",
  "QHelpGlobal": "QtHelp",
  "QHelpIndexWidget": "QtHelp",
  "QMediaAvailabilityControl": "QtMultimedia",
  "QMediaPlayerControl": "QtMultimedia",
  "QAbstractAudioInput": "QtMultimedia",
  "QMediaServiceDefaultDeviceInterface": "QtMultimedia",
  "QMediaTimeRange": "QtMultimedia",
  "QAudioDecoderControl": "QtMultimedia",
  "QCameraImageCapture": "QtMultimedia",
  "QCameraImageProcessing": "QtMultimedia",
  "QAudioRecorder": "QtMultimedia",
  "QCameraCaptureBufferFormatControl": "QtMultimedia",
  "QAudioBuffer": "QtMultimedia",
  "QCameraViewfinderSettingsControl2": "QtMultimedia",
  "QVideoEncoderSettings": "QtMultimedia",
  "QCameraImageCaptureControl": "QtMultimedia",
  "QMediaRecorder": "QtMultimedia",
  "QMediaVideoProbeControl": "QtMultimedia",
  "QAudioEncoderSettings": "QtMultimedia",
  "QImageEncoderControl": "QtMultimedia",
  "QCameraFeedbackControl": "QtMultimedia",
  "QAbstractAudioOutput": "QtMultimedia",
  "QCameraFlashControl": "QtMultimedia",
  "QCameraFocusControl": "QtMultimedia",
  "QMediaPlaylist": "QtMultimedia",
  "QMediaService": "QtMultimedia",
  "QCameraImageProcessingControl": "QtMultimedia",
  "QMediaPlayer": "QtMultimedia",
  "QRadioTuner": "QtMultimedia",
  "QAbstractVideoFilter": "QtMultimedia",
  "QVideoProbe": "QtMultimedia",
  "QMediaControl": "QtMultimedia",
  "QMediaContainerControl": "QtMultimedia",
  "QCameraControl": "QtMultimedia",
  "QMediaMetaData": "QtMultimedia",
  "QRadioTunerControl": "QtMultimedia",
  "QMediaServiceSupportedDevicesInterface": "QtMultimedia",
  "QMediaTimeInterval": "QtMultimedia",
  "QVideoFrame": "QtMultimedia",
  "QCameraViewfinderSettings": "QtMultimedia",
  "QAudioFormat": "QtMultimedia",
  "QAudioDecoder": "QtMultimedia",
  "QMediaBindableInterface": "QtMultimedia",
  "QImageEncoderSettings": "QtMultimedia",
  "QMediaServiceProviderHint": "QtMultimedia",
  "QCameraViewfinderSettingsControl": "QtMultimedia",
  "QRadioData": "QtMultimedia",
  "QMediaServiceSupportedFormatsInterface": "QtMultimedia",
  "QMultimedia": "QtMultimedia",
  "QAudioDeviceInfo": "QtMultimedia",
  "QAudioInput": "QtMultimedia",
  "QCameraInfoControl": "QtMultimedia",
  "QAbstractAudioDeviceInfo": "QtMultimedia",
  "QAudioEncoderSettingsControl": "QtMultimedia",
  "QCameraExposure": "QtMultimedia",
  "QVideoFilterRunnable": "QtMultimedia",
  "QVideoEncoderSettingsControl": "QtMultimedia",
  "QCameraZoomControl": "QtMultimedia",
  "QAudioOutputSelectorControl": "QtMultimedia",
  "QMediaNetworkAccessControl": "QtMultimedia",
  "QMediaServiceFeaturesInterface": "QtMultimedia",
  "QCameraInfo": "QtMultimedia",
  "QSound": "QtMultimedia",
  "QMediaRecorderControl": "QtMultimedia",
  "QMediaObject": "QtMultimedia",
  "QMediaServiceCameraInfoInterface": "QtMultimedia",
  "QMediaServiceProviderFactoryInterface": "QtMultimedia",
  "QMetaDataReaderControl": "QtMultimedia",
  "QAbstractVideoSurface": "QtMultimedia",
  "QMediaServiceProviderPlugin": "QtMultimedia",
  "QVideoSurfaceFormat": "QtMultimedia",
  "QAbstractPlanarVideoBuffer": "QtMultimedia",
  "QAudioSystemPlugin": "QtMultimedia",
  "QVideoWindowControl": "QtMultimedia",
  "QMediaStreamsControl": "QtMultimedia",
  "QRadioDataControl": "QtMultimedia",
  "QAudio": "QtMultimedia",
  "QAudioInputSelectorControl": "QtMultimedia",
  "QMetaDataWriterControl": "QtMultimedia",
  "QAbstractVideoBuffer": "QtMultimedia",
  "QAudioProbe": "QtMultimedia",
  "QMediaGaplessPlaybackControl": "QtMultimedia",
  "QCameraCaptureDestinationControl": "QtMultimedia",
  "QCameraFocus": "QtMultimedia",
  "QMediaResourceList": "QtMultimedia",
  "QCameraFocusZone": "QtMultimedia",
  "QAudioSystemFactoryInterface": "QtMultimedia",
  "QMediaResource": "QtMultimedia",
  "QCameraLocksControl": "QtMultimedia",
  "QVideoDeviceSelectorControl": "QtMultimedia",
  "QSoundEffect": "QtMultimedia",
  "QVideoRendererControl": "QtMultimedia",
  "QMediaContent": "QtMultimedia",
  "QMediaAudioProbeControl": "QtMultimedia",
  "QCameraExposureControl": "QtMultimedia",
  "QCameraFocusZoneList": "QtMultimedia",
  "QAudioOutput": "QtMultimedia",
  "QGeoShape": "QtPositioning",
  "QGeoSatelliteInfoSource": "QtPositioning",
  "QGeoSatelliteInfo": "QtPositioning",
  "QGeoRectangle": "QtPositioning",
  "QGeoCircle": "QtPositioning",
  "QGeoPositionInfoSourceFactory": "QtPositioning",
  "QGeoAreaMonitorInfo": "QtPositioning",
  "QGeoLocation": "QtPositioning",
  "QGeoPositionInfo": "QtPositioning",
  "QNmeaPositionInfoSource": "QtPositioning",
  "QGeoAreaMonitorSource": "QtPositioning",
  "QGeoPositionInfoSource": "QtPositioning",
  "QGeoCoordinate": "QtPositioning",
  "QGeoAddress": "QtPositioning",
  "QEglFSFunctions": "QtPlatformHeaders",
  "QCocoaNativeContext": "QtPlatformHeaders",
  "QWGLNativeContext": "QtPlatformHeaders",
  "QEGLNativeContext": "QtPlatformHeaders",
  "QWindowsWindowFunctions": "QtPlatformHeaders",
  "QXcbWindowFunctions": "QtPlatformHeaders",
  "QGLXNativeContext": "QtPlatformHeaders",
  "QAbstractListModel": "QtCore",
  "QStaticPlugin": "QtCore",
  "QMimeData": "QtCore",
  "QMultiMap": "QtCore",
  "QAnimationGroup": "QtCore",
  "QAbstractProxyModel": "QtCore",
  "QMessageLogContext": "QtCore",
  "QStringMatcher": "QtCore",
  "QSharedMemory": "QtCore",
  "QAbstractTransition": "QtCore",
  "QDynamicPropertyChangeEvent": "QtCore",
  "QStaticArrayData": "QtCore",
  "QPluginLoader": "QtCore",
  "QExplicitlySharedDataPointer": "QtCore",
  "QUrlQuery": "QtCore",
  "QStaticAssertFailure": "QtCore",
  "QModelIndexList": "QtCore",
  "QFutureWatcher": "QtCore",
  "QEasingCurve": "QtCore",
  "QMutableStringListIterator": "QtCore",
  "QDeferredDeleteEvent": "QtCore",
  "QTextEncoder": "QtCore",
  "QStringDataPtr": "QtCore",
  "QVectorIterator": "QtCore",
  "QByteArrayListIterator": "QtCore",
  "QHashNode": "QtCore",
  "QUuid": "QtCore",
  "QCharRef": "QtCore",
  "QDataStream": "QtCore",
  "QSettings": "QtCore",
  "QByteArrayList": "QtCore",
  "QHashData": "QtCore",
  "QCryptographicHash": "QtCore",
  "QInternal": "QtCore",
  "QPointer": "QtCore",
  "QTimeLine": "QtCore",
  "QUrlTwoFlags": "QtCore",
  "QMetaObject": "QtCore",
  "QMimeType": "QtCore",
  "QArrayDataPointerRef": "QtCore",
  "QElapsedTimer": "QtCore",
  "QGlobalStatic": "QtCore",
  "QLineF": "QtCore",
  "QSaveFile": "QtCore",
  "QMutexLocker": "QtCore",
  "QCommandLineParser": "QtCore",
  "QFileSelector": "QtCore",
  "QSignalBlocker": "QtCore",
  "QRegularExpressionMatch": "QtCore",
  "QResource": "QtCore",
  "QPauseAnimation": "QtCore",
  "QPair": "QtCore",
  "QCoreApplication": "QtCore",
  "QLocale": "QtCore",
  "QFutureWatcherBase": "QtCore",
  "QListSpecialMethods": "QtCore",
  "QObjectUserData": "QtCore",
  "QThreadPool": "QtCore",
  "QLatin1Literal": "QtCore",
  "QAtomicPointer": "QtCore",
  "QStorageInfo": "QtCore",
  "QVariantAnimation": "QtCore",
  "QSortFilterProxyModel": "QtCore",
  "QAbstractItemModel": "QtCore",
  "QSharedData": "QtCore",
  "QLinkedListNode": "QtCore",
  "QStack": "QtCore",
  "QIncompatibleFlag": "QtCore",
  "QItemSelectionRange": "QtCore",
  "QArrayData": "QtCore",
  "QChildEvent": "QtCore",
  "QAtomicInteger": "QtCore",
  "QGenericReturnArgument": "QtCore",
  "QStaticByteArrayData": "QtCore",
  "QObjectData": "QtCore",
  "QVariantMap": "QtCore",
  "QByteArrayData": "QtCore",
  "QEventLoopLocker": "QtCore",
  "QBasicMutex": "QtCore",
  "QTime": "QtCore",
  "QAssociativeIterable": "QtCore",
  "QNoDebug": "QtCore",
  "QLinkedListData": "QtCore",
  "QSharedPointer": "QtCore",
  "QSignalMapper": "QtCore",
  "QMutableMapIterator": "QtCore",
  "QByteRef": "QtCore",
  "QHashIterator": "QtCore",
  "QThreadStorage": "QtCore",
  "QCollator": "QtCore",
  "QXmlStreamAttributes": "QtCore",
  "QByteArrayDataPtr": "QtCore",
  "QTemporaryFile": "QtCore",
  "QMessageLogger": "QtCore",
  "QThread": "QtCore",
  "QString": "QtCore",
  "QTextStreamManipulator": "QtCore",
  "QDebugStateSaver": "QtCore",
  "QSet": "QtCore",
  "QMarginsF": "QtCore",
  "QLinkedList": "QtCore",
  "QTranslator": "QtCore",
  "QBitArray": "QtCore",
  "QTextStream": "QtCore",
  "QWinEventNotifier": "QtCore",
  "QReturnArgument": "QtCore",
  "QHash": "QtCore",
  "QMetaType": "QtCore",
  "QVector": "QtCore",
  "QJsonValueRef": "QtCore",
  "QXmlStreamEntityDeclarations": "QtCore",
  "QGenericArgument": "QtCore",
  "QItemSelectionModel": "QtCore",
  "QAbstractState": "QtCore",
  "QAbstractTableModel": "QtCore",
  "QObject": "QtCore",
  "QParallelAnimationGroup": "QtCore",
  "QFinalState": "QtCore",
  "QTemporaryDir": "QtCore",
  "QState": "QtCore",
  "QMutableFutureIterator": "QtCore",
  "QReadWriteLock": "QtCore",
  "QIntegerForSize": "QtCore",
  "QMutableListIterator": "QtCore",
  "QXmlStreamNamespaceDeclaration": "QtCore",
  "QEnableSharedFromThis": "QtCore",
  "QDirIterator": "QtCore",
  "QLoggingCategory": "QtCore",
  "QStateMachine": "QtCore",
  "QUrl": "QtCore",
  "QMapDataBase": "QtCore",
  "QRegularExpression": "QtCore",
  "QFunctionPointer": "QtCore",
  "QScopedValueRollback": "QtCore",
  "QFuture": "QtCore",
  "QFlag": "QtCore",
  "QException": "QtCore",
  "QAtomicInt": "QtCore",
  "QMimeDatabase": "QtCore",
  "QLockFile": "QtCore",
  "QTextStreamFunction": "QtCore",
  "QFileSystemWatcher": "QtCore",
  "QTextBoundaryFinder": "QtCore",
  "QTypeInfoMerger": "QtCore",
  "QFutureIterator": "QtCore",
  "QRegExp": "QtCore",
  "QObjectCleanupHandler": "QtCore",
  "QBBSystemLocaleData": "QtCore",
  "QSequentialIterable": "QtCore",
  "QAbstractNativeEventFilter": "QtCore",
  "QScopedPointer": "QtCore",
  "QJsonDocument": "QtCore",
  "QWeakPointer": "QtCore",
  "QMapData": "QtCore",
  "QLine": "QtCore",
  "QMutableByteArrayListIterator": "QtCore",
  "QTimeZone": "QtCore",
  "QFutureInterface": "QtCore",
  "QTimerEvent": "QtCore",
  "QAbstractEventDispatcher": "QtCore",
  "QContiguousCacheData": "QtCore",
  "QSizeF": "QtCore",
  "QRect": "QtCore",
  "QByteArray": "QtCore",
  "QMetaTypeIdQObject": "QtCore",
  "QTypeInfo": "QtCore",
  "QLibrary": "QtCore",
  "QMutableVectorIterator": "QtCore",
  "QForeachContainer": "QtCore",
  "QPersistentModelIndex": "QtCore",
  "QRegularExpressionMatchIterator": "QtCore",
  "QXmlStreamWriter": "QtCore",
  "QUnhandledException": "QtCore",
  "QIODevice": "QtCore",
  "QMapIterator": "QtCore",
  "QSetIterator": "QtCore",
  "QXmlStreamEntityDeclaration": "QtCore",
  "QMessageAuthenticationCode": "QtCore",
  "QFactoryInterface": "QtCore",
  "QStringList": "QtCore",
  "QThreadStorageData": "QtCore",
  "QCache": "QtCore",
  "QEvent": "QtCore",
  "QQueue": "QtCore",
  "QChar": "QtCore",
  "QContiguousCacheTypedData": "QtCore",
  "QDate": "QtCore",
  "QProcess": "QtCore",
  "QXmlStreamNotationDeclaration": "QtCore",
  "QMetaEnum": "QtCore",
  "QVariantHash": "QtCore",
  "QSocketNotifier": "QtCore",
  "QHashDummyValue": "QtCore",
  "QJsonValuePtr": "QtCore",
  "QStringData": "QtCore",
  "QMapNodeBase": "QtCore",
  "QStringRef": "QtCore",
  "QIdentityProxyModel": "QtCore",
  "QScopedPointerArrayDeleter": "QtCore",
  "QAbstractAnimation": "QtCore",
  "QXmlStreamEntityResolver": "QtCore",
  "QFutureInterfaceBase": "QtCore",
  "QStringBuilder": "QtCore",
  "QContiguousCache": "QtCore",
  "QLatin1String": "QtCore",
  "QPropertyAnimation": "QtCore",
  "QVariant": "QtCore",
  "QRunnable": "QtCore",
  "QProcessEnvironment": "QtCore",
  "QJsonParseError": "QtCore",
  "QLatin1Char": "QtCore",
  "QFileDevice": "QtCore",
  "QMetaProperty": "QtCore",
  "QMetaTypeId2": "QtCore",
  "QRectF": "QtCore",
  "QSystemSemaphore": "QtCore",
  "QEventTransition": "QtCore",
  "QJsonObject": "QtCore",
  "QPoint": "QtCore",
  "QLinkedListIterator": "QtCore",
  "QXmlStreamNotationDeclarations": "QtCore",
  "QArrayDataPointer": "QtCore",
  "QDebug": "QtCore",
  "QStandardPaths": "QtCore",
  "QReadLocker": "QtCore",
  "QMap": "QtCore",
  "QWriteLocker": "QtCore",
  "QListIterator": "QtCore",
  "QSize": "QtCore",
  "QMutex": "QtCore",
  "QHistoryState": "QtCore",
  "QListData": "QtCore",
  "QStringListIterator": "QtCore",
  "QMutableSetIterator": "QtCore",
  "QScopedPointerDeleter": "QtCore",
  "QTimer": "QtCore",
  "QByteArrayMatcher": "QtCore",
  "QBitRef": "QtCore",
  "QObjectList": "QtCore",
  "QBuffer": "QtCore",
  "QJsonValueRefPtr": "QtCore",
  "QAnimationDriver": "QtCore",
  "QDateTime": "QtCore",
  "QList": "QtCore",
  "QScopedPointerDeleteLater": "QtCore",
  "QMutableLinkedListIterator": "QtCore",
  "QBasicTimer": "QtCore",
  "QXmlStreamStringRef": "QtCore",
  "QPointF": "QtCore",
  "QMultiHash": "QtCore",
  "QFileInfo": "QtCore",
  "QMetaClassInfo": "QtCore",
  "QJsonValue": "QtCore",
  "QVariantList": "QtCore",
  "QFutureSynchronizer": "QtCore",
  "QVarLengthArray": "QtCore",
  "QFile": "QtCore",
  "QCollatorSortKey": "QtCore",
  "QScopedArrayPointer": "QtCore",
  "QJsonArray": "QtCore",
  "QMutableHashIterator": "QtCore",
  "QVariantComparisonHelper": "QtCore",
  "QStaticStringData": "QtCore",
  "QDir": "QtCore",
  "QTextDecoder": "QtCore",
  "QScopedPointerPodDeleter": "QtCore",
  "QMetaTypeId": "QtCore",
  "QXmlStreamReader": "QtCore",
  "QSignalTransition": "QtCore",
  "QScopedPointerObjectDeleteLater": "QtCore",
  "QMapNode": "QtCore",
  "QLibraryInfo": "QtCore",
  "QSharedDataPointer": "QtCore",
  "QSysInfo": "QtCore",
  "QModelIndex": "QtCore",
  "QFileInfoList": "QtCore",
  "QTextCodec": "QtCore",
  "QMargins": "QtCore",
  "QSemaphore": "QtCore",
  "QXmlStreamAttribute": "QtCore",
  "QMetaMethod": "QtCore",
  "QItemSelection": "QtCore",
  "QXmlStreamNamespaceDeclarations": "QtCore",
  "QCommandLineOption": "QtCore",
  "QWaitCondition": "QtCore",
  "QStringListModel": "QtCore",
  "QArgument": "QtCore",
  "QSequentialAnimationGroup": "QtCore",
  "QEventLoop": "QtCore",
  "QFlags": "QtCore",
  "QGyroscopeReading": "QtSensors",
  "QRotationSensor": "QtSensors",
  "QAccelerometer": "QtSensors",
  "QAmbientLightFilter": "QtSensors",
  "QSensorManager": "QtSensors",
  "QGyroscope": "QtSensors",
  "QHolsterReading": "QtSensors",
  "QPressureFilter": "QtSensors",
  "QIRProximityReading": "QtSensors",
  "QCompassFilter": "QtSensors",
  "QCompassReading": "QtSensors",
  "QPressureSensor": "QtSensors",
  "QTiltSensor": "QtSensors",
  "QProximityReading": "QtSensors",
  "QSensor": "QtSensors",
  "QHolsterFilter": "QtSensors",
  "QLightSensor": "QtSensors",
  "QHolsterSensor": "QtSensors",
  "QSensorPluginInterface": "QtSensors",
  "QAccelerometerFilter": "QtSensors",
  "QLightReading": "QtSensors",
  "QSensorGestureManager": "QtSensors",
  "QMagnetometerReading": "QtSensors",
  "QOrientationSensor": "QtSensors",
  "QTapSensor": "QtSensors",
  "QAmbientLightSensor": "QtSensors",
  "QAltimeter": "QtSensors",
  "QSensorFilter": "QtSensors",
  "QProximitySensor": "QtSensors",
  "QProximityFilter": "QtSensors",
  "QAmbientLightReading": "QtSensors",
  "QSensorBackendFactory": "QtSensors",
  "QIRProximityFilter": "QtSensors",
  "QOrientationReading": "QtSensors",
  "QSensorGesture": "QtSensors",
  "QOrientationFilter": "QtSensors",
  "QSensorReading": "QtSensors",
  "QDistanceFilter": "QtSensors",
  "QAltimeterFilter": "QtSensors",
  "QIRProximitySensor": "QtSensors",
  "QTapReading": "QtSensors",
  "QLightFilter": "QtSensors",
  "QPressureReading": "QtSensors",
  "QTiltFilter": "QtSensors",
  "QSensorGestureRecognizer": "QtSensors",
  "QCompass": "QtSensors",
  "QDistanceSensor": "QtSensors",
  "QTapFilter": "QtSensors",
  "QSensorBackend": "QtSensors",
  "QAccelerometerReading": "QtSensors",
  "QMagnetometer": "QtSensors",
  "QSensorChangesInterface": "QtSensors",
  "QDistanceReading": "QtSensors",
  "QRotationReading": "QtSensors",
  "QGyroscopeFilter": "QtSensors",
  "QAmbientTemperatureFilter": "QtSensors",
  "QAltimeterReading": "QtSensors",
  "QRotationFilter": "QtSensors",
  "QAmbientTemperatureSensor": "QtSensors",
  "QAmbientTemperatureReading": "QtSensors",
  "QSensorGesturePluginInterface": "QtSensors",
  "QTiltReading": "QtSensors",
  "QMagnetometerFilter": "QtSensors",
};

final _qtHeaderRe = new RegExp(r'Q[A-Z]\w+$');
bool looksLikeQtHeader(String header) => _qtHeaderRe.hasMatch(basename(header));

final _qtLikeNameRe = new RegExp(r'Q[A-Z]\w+\b');
bool looksLikeHasQtName(String s) => _qtLikeNameRe.hasMatch(s);

addQtSupport(Installation installation) {
  if (installation.installationBuilder == null) {
    installation.installationBuilder =
        new CmakeInstallationBuilder.fromInstallation(installation);
  }

  installation.installationBuilder
    ..onLibCmake = (LibCmake libCmake) {
      if (libCmake.lib.classes.any((cls) => cls is QtClass)) {
        final lib = libCmake.lib;

        libCmake.addLibrary.snippets.add(br(libCmake.lib.headers.map((header) {
          final headerMoc = '${header.id.emacs}-moc';
          libCmake.libSourceFilenames.add('\${$headerMoc}');
          final relPath = relative(installation.cppPath, from: header.filePath);
          return 'qt5_wrap_cpp($headerMoc ${join(relPath, header.includeFilePath)})';
        }), '\n\n'));

        libCmake.targetIncludeDirectories.snippets.add(
            '\ntarget_include_directories(${lib.id.snake} PUBLIC \${Qt5Widgets_INCLUDE_DIRS})');

        libCmake.targetCompileOptions.snippets
            .add('\ntarget_compile_options(${lib.id.snake} PRIVATE "-fPIE")');
      }
    }
    ..onInstallationCmake = (InstallationCmake installationCmake) {
      print('Got installationCmake!');
    };
}

// end <part qt_basics>
